import torch
import matplotlib.pyplot as plt
partitions = 4
data='WikiTalk'
method = 'ours'
local_edge_comm_list = [torch.tensor([]) for _ in range(partitions)]
remote_edge_comm_list = [torch.tensor([]) for _ in range(partitions)]
calculate = [torch.tensor([]) for _ in range(partitions)]
for r in range(partitions):
    comm = torch.load('{}/comm/comm_{}_0_{}_{}_recent_0.1_all_update_2.pt'.format(data,method,partitions,r))
    local_access,remote_access,local_edge_access,remote_edge_access,local_comm,remote_comm,local_edge_comm,remote_edge_comm = comm
    #local_access = torch.tensor(local_access)
    #remote_access = torch.tensor(remote_access)
    #local_comm = torch.tensor(local_comm)
    #remote_comm = torch.tensor(remote_comm)
    local_edge_comm_list[r] = torch.tensor(local_edge_comm)
    remote_edge_comm_list[r] = torch.tensor(remote_edge_comm)
    calculate[r] = local_edge_comm_list[r] + remote_edge_comm[r]
cal = torch.stack(calculate)[:,:12]
cal_max,_ = torch.max(cal,dim = 0)
cal_min = torch.sum(cal,dim = 0)/partitions
x = torch.arange(cal.shape[1])
y0 = cal_max/cal_min
y1 = torch.ones(cal.shape[1])
# 堆叠柱状图
fig, ax = plt.subplots()
bar_width = 0.35
ax.bar(x,cal_max,bar_width,label='max overhead')
ax.bar(x+bar_width,cal_min,bar_width,label='avg overhead')
#bars_A = ax.plot(x, cal[0] , label='rank = 0')
#bars_B = ax.plot(x, cal[1] , label='rank = 1')
#bars_C = ax.plot(x, cal[2] , label='rank = 2')
#bars_D = ax.plot(x, cal[3] , label='rank = 3')
#avg = y1*torch.mean(y0.to(torch.float))
#ax.plot(x,avg,color='orange',label='EB average')
#ax.plot(x,y1,color='black',label='average')
plt.xlabel('Batch Index')
plt.ylabel('Computational Load Balace')
plt.legend()
if method == 'dis_tgl':
    method = 'DisTGL'
plt.title('{}({} {}-partitions)'.format(data,method,partitions))
plt.savefig('{}_{}_balance.png'.format(data,method))
